diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index 30d438d06df9..a600bc7cc7fc 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -8004,6 +8004,15 @@ catchpoint::catchpoint (struct gdbarch *gdbarch, bool temp,
   pspace = current_program_space;
 }
 
+/* Notify interpreters and observers that breakpoint B was created.  */
+
+static void
+notify_breakpoint_created (breakpoint *b)
+{
+  interps_notify_breakpoint_created (b);
+  gdb::observers::breakpoint_created.notify (b);
+}
+
 breakpoint *
 install_breakpoint (int internal, std::unique_ptr<breakpoint> &&arg, int update_gll)
 {
@@ -8013,7 +8022,8 @@ install_breakpoint (int internal, std::unique_ptr<breakpoint> &&arg, int update_
     set_tracepoint_count (breakpoint_count);
   if (!internal)
     mention (b);
-  gdb::observers::breakpoint_created.notify (b);
+
+  notify_breakpoint_created (b);
 
   if (update_gll)
     update_global_location_list (UGLL_MAY_INSERT);
diff --git a/gdb/interps.c b/gdb/interps.c
index c727913e4806..f8f97513ac66 100644
--- a/gdb/interps.c
+++ b/gdb/interps.c
@@ -559,6 +559,14 @@ interps_notify_tsv_modified (const trace_state_variable *tsv)
   interps_notify (&interp::on_tsv_modified, tsv);
 }
 
+/* See interps.h.  */
+
+void
+interps_notify_breakpoint_created (breakpoint *b)
+{
+  interps_notify (&interp::on_breakpoint_created, b);
+}
+
 /* This just adds the "interpreter-exec" command.  */
 void _initialize_interpreter ();
 void
diff --git a/gdb/interps.h b/gdb/interps.h
index 7bd57cb05ecc..b1e2903e1571 100644
--- a/gdb/interps.h
+++ b/gdb/interps.h
@@ -166,6 +166,9 @@ class interp : public intrusive_list_node<interp>
   /* Notify the interpreter that trace state variable TSV was modified.  */
   virtual void on_tsv_modified (const trace_state_variable *tsv) {}
 
+  /* Notify the interpreter that breakpoint B was created.  */
+  virtual void on_breakpoint_created (breakpoint *b) {}
+
 private:
   /* The memory for this is static, it comes from literal strings (e.g. "cli").  */
   const char *m_name;
@@ -335,6 +338,9 @@ extern void interps_notify_tsv_deleted (const trace_state_variable *tsv);
 /* Notify all interpreters that trace state variable TSV was modified.  */
 extern void interps_notify_tsv_modified (const trace_state_variable *tsv);
 
+/* Notify all interpreters that breakpoint B was created.  */
+extern void interps_notify_breakpoint_created (breakpoint *b);
+
 /* well-known interpreters */
 #define INTERP_CONSOLE		"console"
 #define INTERP_MI2             "mi2"
diff --git a/gdb/mi/mi-interp.c b/gdb/mi/mi-interp.c
index 65b9bd3693a2..d7df572546c4 100644
--- a/gdb/mi/mi-interp.c
+++ b/gdb/mi/mi-interp.c
@@ -60,7 +60,6 @@ static int mi_interp_query_hook (const char *ctlstr, va_list ap)
 static void mi_insert_notify_hooks (void);
 static void mi_remove_notify_hooks (void);
 
-static void mi_breakpoint_created (struct breakpoint *b);
 static void mi_breakpoint_deleted (struct breakpoint *b);
 static void mi_breakpoint_modified (struct breakpoint *b);
 static void mi_command_param_changed (const char *param, const char *value);
@@ -588,10 +587,8 @@ mi_print_breakpoint_for_event (struct mi_interp *mi, breakpoint *bp)
     }
 }
 
-/* Emit notification about a created breakpoint.  */
-
-static void
-mi_breakpoint_created (struct breakpoint *b)
+void
+mi_interp::on_breakpoint_created (breakpoint *b)
 {
   if (mi_suppress_notification.breakpoint)
     return;
@@ -599,22 +596,13 @@ mi_breakpoint_created (struct breakpoint *b)
   if (b->number <= 0)
     return;
 
-  SWITCH_THRU_ALL_UIS ()
-    {
-      struct mi_interp *mi = as_mi_interp (top_level_interpreter ());
-
-      if (mi == NULL)
-	continue;
-
-      target_terminal::scoped_restore_terminal_state term_state;
-      target_terminal::ours_for_output ();
+  target_terminal::scoped_restore_terminal_state term_state;
+  target_terminal::ours_for_output ();
 
-      gdb_printf (mi->event_channel,
-		  "breakpoint-created");
-      mi_print_breakpoint_for_event (mi, b);
+  gdb_printf (this->event_channel, "breakpoint-created");
+  mi_print_breakpoint_for_event (this, b);
 
-      gdb_flush (mi->event_channel);
-    }
+  gdb_flush (this->event_channel);
 }
 
 /* Emit notification about deleted breakpoint.  */
@@ -1009,8 +997,6 @@ _initialize_mi_interp ()
   interp_factory_register (INTERP_MI4, mi_interp_factory);
   interp_factory_register (INTERP_MI, mi_interp_factory);
 
-  gdb::observers::breakpoint_created.attach (mi_breakpoint_created,
-					     "mi-interp");
   gdb::observers::breakpoint_deleted.attach (mi_breakpoint_deleted,
 					     "mi-interp");
   gdb::observers::breakpoint_modified.attach (mi_breakpoint_modified,
diff --git a/gdb/mi/mi-interp.h b/gdb/mi/mi-interp.h
index 11ec5ddf3781..bbd47422e962 100644
--- a/gdb/mi/mi-interp.h
+++ b/gdb/mi/mi-interp.h
@@ -66,6 +66,7 @@ class mi_interp final : public interp
   void on_tsv_created (const trace_state_variable *tsv) override;
   void on_tsv_deleted (const trace_state_variable *tsv) override;
   void on_tsv_modified (const trace_state_variable *tsv) override;
+  void on_breakpoint_created (breakpoint *b) override;
 
   /* MI's output channels */
   mi_console_file *out;